#include <iostream>
#include <string>
#include <sstream>
#include <vector>
#include <algorithm>
#include <cstdarg>
#include <iomanip>

#include <boost/shared_array.hpp>

#include "midi_byte_array.h"

using namespace std;

namespace MIDI {
	typedef unsigned char byte;
	byte sysex = 0xf0;
	byte eox = 0xf7;
}

int main()
{
	MidiByteArray buf;
	MidiByteArray mackie_sysex_hdr( 5, MIDI::sysex, 0x0, 0x0, 0x66, 0x10 );
	buf << mackie_sysex_hdr << 0x0 << MIDI::eox;
	
	// send device query
	cout << "buf: " << buf << endl;
	boost::shared_array<MIDI::byte> bytes = buf.bytes();
	for( int i = 0; i < buf.size(); ++i )
	{
		cout << "i: " << i << " " << (int)bytes[i] << endl;
	}
	
	// test emptying
	buf.clear();
	cout << "buf: " << buf << endl;
	
	return 0;
}

